(**********************************************************************)
(* (c) Greg Morrisett, Neal Glew, David Walker,                       *)
(*     June 1998, all rights reserved.                                *)
(**********************************************************************)

(* Cogen_analyze:  Analysis pass for code generation. *)
open Ycalculus
open Ycon
open Ident

type info = {deadvars : ident Set.set}  (* Dead variable info *)
(* Additional dead variable info for cases *)
type caseinfo = {switchdead : ident Set.set; defdead : ident Set.set} 
type fninfo = {framesz : int}           (* Framesize info *)

(* Return:
   1. For the toplevel expression, return the maximum number of variables live
       at any time. 
   2. table associating with each letbound ident, the variables which become 
       dead after that point 
   3. table associating with each function, the frame size
*)
val analyze : 
    ymodule -> int * ((ident, info) Hashtbl.t * (ident, caseinfo) Hashtbl.t) 
	* (ident, fninfo) Hashtbl.t
val print_analysis : 
    int * ((ident, info) Hashtbl.t * (ident, caseinfo) Hashtbl.t) * 
    (ident, fninfo) Hashtbl.t -> unit
