(**********************************************************************)
(* (c) Greg Morrisett, Neal Glew, Chris Hawblitzel,                   *)
(*     June 1998, all rights reserved.                                *)
(**********************************************************************)
(* this flag controls whether or not the file is compiled with extra
 * support for debugging null pointer checks.  The generated code will
 * run slower.  Default is true.
 *)
val debug_null : bool ref 

(* compiles file to be loadable by the Popcorn dynamic loading
   package.  Default is false *)
val convert_to_loadable : bool ref

(* compiles file to export its symbols to dynamically loadable files.
   Default is false (should be true, but we have a limited impl
   right now) *)
val export_to_loadable : bool ref

(* if false  (default), use LX to represent popcorn types, 
   otherwise, use TAL's built-in Rep types *)
val dyn_native : bool ref

val code_gen : string->Tal.int_ref->Tal.int_ref->bool->
  (Popsyntax.top_decl list * Poptype.global_env)->
    (Tal.tal_imp * Tal.tal_int * Tal.tal_int)

