
(* DEBUG 
val debug : bool ref
 END DEBUG *)

type global_env = 
    { structs   : (Popsyntax.type_name,Popsyntax.structdecl) Dict.dict;
      unions    : (Popsyntax.type_name,Popsyntax.uniondecl)  Dict.dict;
      abstypes  : (Popsyntax.type_name,Popsyntax.absdecl)   Dict.dict;
      abstracts : (Popsyntax.type_name,(Popsyntax.var list * bool)) Dict.dict;
      (* the bool ref is set to true if the global is referenced *)
      globals   : (Popsyntax.var,(bool ref * Popsyntax.typ)) Dict.dict;
      exceptions: (Popsyntax.var,Popsyntax.typ) Dict.dict;
      functions : (Popsyntax.var,Popsyntax.typ) Dict.dict;
      open_typs : (Popsyntax.type_name,Popsyntax.type_name) Dict.dict;
      open_vals : (Popsyntax.var,Popsyntax.var) Dict.dict
    } 

val type_check : 
    bool -> Popsyntax.top_decl list -> (Popsyntax.top_decl list) * global_env

val type_subst :
    (Popsyntax.var * Popsyntax.typ) list -> Popsyntax.typ -> Popsyntax.typ

(* Cyclone *)
val doesSpliceRet: Popsyntax.stmt -> bool
(* End Cyclone *)

val eliminate_prefixes : Popsyntax.top_decl list -> Popsyntax.top_decl list

(* dynamic linker *)
val default_initializer : global_env -> Popsyntax.typ -> Popsyntax.location -> Popsyntax.varset -> Popsyntax.exp
(* dynamic linker *)
