#include <mlvalues.h>
#include <alloc.h>
#include <memory.h>
#include <stdlib.h>

#define FLOATSIZE  4
#define DOUBLESIZE 8


float to_float(value v) {
  int i;
  float f;
  char *s = (char *)&f;

  for (i=0; i<FLOATSIZE; i++) {
    s[i] = Byte(v,i);
  }

  return f;
}

double to_double(value v) {
  int i;
  double d;
  char *s = (char*)&d;

  for (i=0; i<DOUBLESIZE; i++) {
    s[i] = Byte(v,i);
  }

  return d;
}

void from_float(float f, value v) {
  int i;
  char *s = (char *)&f;

  for (i=0; i<FLOATSIZE; i++) {
    Byte(v,i) = s[i];
  }

  return;
}

void from_double(double d, value v) {
  int i;
  char *s = (char *)&d;

  for (i=0; i<DOUBLESIZE; i++) {
    Byte(v,i) = s[i];
  }

  return;
}

value d_to_h32(value digits) {
  float f = (float)(atof(String_val(digits))); 
  value v = alloc_string(FLOATSIZE);

  from_float(f,v);

  return v;
}

value d_to_h64(value digits) {
  double d = (double)(atof(String_val(digits)));
  value v = alloc_string(DOUBLESIZE);

  from_double(d,v);

  return v;
}

value negate_f32(value v) {
  float f = to_float(v);

  from_float(-f,v);

  return v;
}

value negate_f64(value v) {
  float d = to_double(v);

  from_double(-d,v);

  return v;
}
